From: Steven Rostedt <rostedt@goodmis.org>
To: linux-kernel@vger.kernel.org
Cc: Ingo Molnar <mingo@kernel.org>,
Andrew Morton <akpm@linux-foundation.org>,
Tom Zanussi <zanussi@kernel.org>
Subject: [for-linus][PATCH 07/15] selftests/ftrace: Add test case for synthetic event dynamic strings
Date: Tue, 06 Oct 2020 10:34:53 -0400 [thread overview]
Message-ID: <20201006143511.648495724@goodmis.org> (raw)
In-Reply-To: 20201006143446.182666356@goodmis.org
From: Tom Zanussi <zanussi@kernel.org>
Add a selftest that defines and traces a synthetic event that uses a
dynamic string event field.
Link: https://lkml.kernel.org/r/74445afb005046d76d59fb06696a2ceaa164dec9.1601848695.git.zanussi@kernel.org
Signed-off-by: Tom Zanussi <zanussi@kernel.org>
Signed-off-by: Steven Rostedt (VMware) <rostedt@goodmis.org>
---
.../trigger-synthetic-event-dynstring.tc | 31 +++++++++++++++++++
1 file changed, 31 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-synthetic-event-dynstring.tc
diff --git a/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-synthetic-event-dynstring.tc b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-synthetic-event-dynstring.tc
new file mode 100644
index 000000000000..3d65c856eca3
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/trigger/inter-event/trigger-synthetic-event-dynstring.tc
@@ -0,0 +1,31 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: event trigger - test inter-event histogram trigger trace action with dynamic string param
+# requires: set_event synthetic_events events/sched/sched_process_exec/hist "char name[]' >> synthetic_events":README
+
+fail() { #msg
+ echo $1
+ exit_fail
+}
+
+echo "Test create synthetic event"
+
+echo 'ping_test_latency u64 lat; char filename[]' > synthetic_events
+if [ ! -d events/synthetic/ping_test_latency ]; then
+ fail "Failed to create ping_test_latency synthetic event"
+fi
+
+echo "Test create histogram for synthetic event using trace action and dynamic strings"
+echo "Test histogram dynamic string variables,simple expression support and trace action"
+
+echo 'hist:key=pid:filenamevar=filename:ts0=common_timestamp.usecs' > events/sched/sched_process_exec/trigger
+echo 'hist:key=pid:lat=common_timestamp.usecs-$ts0:onmatch(sched.sched_process_exec).ping_test_latency($lat,$filenamevar) if comm == "ping"' > events/sched/sched_process_exit/trigger
+echo 'hist:keys=filename,lat:sort=filename,lat' > events/synthetic/ping_test_latency/trigger
+
+ping $LOCALHOST -c 5
+
+if ! grep -q "ping" events/synthetic/ping_test_latency/hist; then
+ fail "Failed to create dynamic string trace action inter-event histogram"
+fi
+
+exit 0
--
2.28.0
next prev parent reply other threads:[~2020-10-06 14:35 UTC|newest]
Thread overview: 17+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-10-06 14:34 [for-linus][PATCH 00/15] tracing: Some final updates for 5.10 Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 01/15] ftrace: Fix some typos in comment Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 02/15] tracing: Change STR_VAR_MAX_LEN Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 03/15] tracing: Fix parse_synth_field() error handling Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 04/15] tracing: Save normal string variables Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 05/15] tracing: Add support for dynamic strings to synthetic events Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 06/15] tracing: Add README information for synthetic_events file Steven Rostedt
2020-10-06 14:34 ` Steven Rostedt [this message]
2020-10-06 14:34 ` [for-linus][PATCH 08/15] tracing: Change synthetic event string format to limit printed length Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 09/15] ftrace: Use fls() to get the bits for dup_hash() Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 10/15] ftrace: Simplify the hash calculation Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 11/15] ftrace: Simplify the dyn_ftrace->flags macro Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 12/15] ftrace: Simplify the calculation of page number for ftrace_page->records Steven Rostedt
2020-10-06 14:34 ` [for-linus][PATCH 13/15] ftrace: Format variable declarations of ftrace_allocate_records Steven Rostedt
2020-10-06 14:35 ` [for-linus][PATCH 14/15] ftrace: ftrace_global_list is renamed to ftrace_ops_list Steven Rostedt
2020-10-06 14:35 ` [for-linus][PATCH 15/15] tracing: Remove a pointless assignment Steven Rostedt
2020-10-06 15:01 ` [for-linus][PATCH 00/15] tracing: Some final updates for 5.10 Steven Rostedt
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20201006143511.648495724@goodmis.org \
--to=rostedt@goodmis.org \
--cc=akpm@linux-foundation.org \
--cc=linux-kernel@vger.kernel.org \
--cc=mingo@kernel.org \
--cc=zanussi@kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox